# Licensed Materials - Property of IBM
#
# 09N6996
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

#############################################################

RSRC_DATA=$CMD_DIR/data
if [ ! -d $RSRC_DATA ]
then
    mkdir $RSRC_DATA
    chmod 700 $RSRC_DATA
fi

RC=0

# get current state of emulated resource, including if the state is "locked"

if [ -s ${RSRC_DATA}/${RSRC_NAME} ]
then
    read RSRC_OPSTATE OPSTATE_LOCKED < ${RSRC_DATA}/${RSRC_NAME}
else
    RSRC_OPSTATE=$TSA_OFFLINE
    OPSTATE_LOCKED=
fi

case $RSRC_ACTION in
    start)
        record_tsa_action $RSRC_ACTION $RSRC_NAME "-"
        if [ -z "$OPSTATE_LOCKED" ]
        then
            echo "$TSA_ONLINE" > ${RSRC_DATA}/${RSRC_NAME}
        else
            smha_debug_tsa "On start, locked OpState is $RSRC_OPSTATE for $RSRC_NAME"
        fi
    ;;

    stop)
        record_tsa_action $RSRC_ACTION $RSRC_NAME "-"
        if [ -z "$OPSTATE_LOCKED" ]
        then
            echo "$TSA_OFFLINE" > ${RSRC_DATA}/${RSRC_NAME}
        else
            smha_debug_tsa "On stop, locked OpState is $RSRC_OPSTATE for $RSRC_NAME"
        fi
    ;;

    status)
        RC=$RSRC_OPSTATE
    ;;

    *)
        fatal_error "Bad parameter to $PROGNAME. Action is:${RSRC_ACTION}"
    ;;
esac

smha_record_tsa_action $RSRC_ACTION $RSRC_NAME $RC

# sourcing script must exit with the RC value
