#!/usr/bin/perl -w
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.


use strict;
package lib::Crypt;

my $MD5 = '$1$';
my $SHA512 = '$6$';

sub encypt_password{
	my ($pw, $type) = @_;
	my $salt;
	if ($type eq "MD5") {
		$salt=$MD5.generate_salt(8).'$';
	} elsif ($type eq "SHA512") {
		$salt=$SHA512.generate_salt(16).'$';
	}
    return crypt($pw, $salt);
}

sub generate_salt {
	my ($salt_count) = @_;
	my $salt = "";
	my $char;
    for (my $i = 0; $i < $salt_count; $i++) {
        my $number = int(rand(64));
        if ($number < 10) { # 0-9
                $char = $number;
        } elsif ($number == 63) {
                $char = '/';
        } elsif ($number == 62) {
        	   $char = '.';
        } elsif ($number >=10 && $number < 36) { #10-35
                $char = chr(ord('A') + ($number - 10));
        } else {
                $char = chr(ord('a') + ($number - 36));
        }

        $salt .= $char;
    }
    return $salt;
}

#given a user and password, verify the existing password
#returns true if correct, false otherwise
sub verify_password {
	my ($user, $enteredpw) = @_;
	
	my $pwd = (getpwnam($user))[1];
	
	print $pwd, $user;
	
	if (crypt($enteredpw, $pwd) ne $pwd) {
		return 0;
	} else {
		return 1;
	}
}

1;
