#!/bin/bash
# Licensed Materials - Property of IBM
# 
# 09N6996
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#
PROGNAME=$(basename $0)
PROGPATH=$(dirname $0)
#### Use a special path for TSA monitoring scripts
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin
export PATH

EXPLOITER_COMMON_CODE=/opt/ibm/director/ha/bin/include/smha_exploiter_common.sh

if [ -f $EXPLOITER_COMMON_CODE ]; then
    source $EXPLOITER_COMMON_CODE
else
    echo "$PROGNAME:Exploiter common code not found."
    exit 1
fi
#############################################################

RC=$TSA_UNKNOWN

Action=${1}

case ${Action} in
start)
    record_tsa_action $Action sample "-"

    #normally, you would call your startup process here
    #e.g. /etc/init.d/mydaemon start
    smha_debug_tsa "sample program started"
    touch $PROGPATH/sampleonline
    ;;
stop)
    record_tsa_action $Action sample "-"

    #normally, you would call your stop process here
    #e.g. /etc/init.d/mydaemon stop
    # you may want to perform some sanity checking here to make sure
    # the process really died.  Especially in the case if the process
    # contains files in shared storage which needs to be unmounted
    # in the case of a manual failover.
    
    smha_debug_tsa "sample program stopped"
    if [ -f $PROGPATH/sampleonline ]; then
        rm $PROGPATH/sampleonline
    fi
    ;;

status)
    #normally, you would call your status process here
    #e.g. /etc/init.d/mydaemon status
    #statusrc=$?
    if [ -f $PROGPATH/sampleonline ]; then
        RC=${TSA_ONLINE}
    else
        RC=${TSA_OFFLINE}
    fi
    
    ;;
esac
#debug_tsa "$PROGNAME $Action: rc=$RC"
smha_record_tsa_action $Action sample $RC
exit $RC
